import { Attribute } from "./nodes";
export declare class CompiledAttribute {
    name: string;
    type: Attribute["type"];
    scope: Scope;
    source: Attribute;
    expanded: string | string[] | undefined;
    constructor(name: string, type: Attribute["type"], scope: Scope, source: Attribute);
    get isExpanded(): boolean;
    get fullName(): string;
}
export declare class Scope extends Map<string, CompiledAttribute> {
    name: string;
    parent?: Scope;
    children: Scope[];
    constructor(name: string, parent?: Scope);
}
export declare class ScopeManager {
    global: Scope;
    current: Scope;
    constructor();
    push(newScope: Scope | string): false | Scope;
    pop(): void;
    set(name: string, value: Attribute): void;
    get(name: string, scope?: Scope): CompiledAttribute;
    getPath(scope?: Scope): string;
}
